//declaration des variables globales de l'application

mode='paiement';
numeroTelepaiement='';
myNavigateur = navigator.userAgent;
myNavigateur = myNavigateur.replace(/"/g, '');
// Version du client, doit être homogène entre IOS et Android. Cette version doit etre valide cote serveur.
myVersion='1.0.7';
// l'URL suivante est celle du serveur TAM. Seule celle de production doit etre decommentee pour le livrable final.
// Production
host = 'https://tam.ca.gouv.fr';

// Recette CNT4
//host = 'https://tam-rct.as8677.net';

// Pre-prod
//host = 'https://tam-pprd-scl.tlp.as8677.net';

// Test en local
// host = 'http://10.0.2.2:8080';
//host = 'http://192.168.43.240:8080';

fxName = 'DemanderValidationApplication';
infosPourJustificatif = '';
infosAmende = '';
androidVersion = parseFloat(myNavigateur.slice(myNavigateur.indexOf("Android")+8));
listeLangues = ['fr','es','de','nl','it','en'];
isAmendeEtrangere = false;
isPayableSips2 = false;
amendeConsignable = true;
currentLanguage = 'fr';
deviceLanguageSetting = '';
dateCopyright = new Date().getFullYear();
afficherMentionSiPresent = true;
afficherMessageTimeout = true;
var hauteurDIV = 0;

//booleen permettant de gerer correctement le resume de l'application
//lorsqu'on revient du scanner, l'application fait un resume
//on bloque le resume, sinon erreur technique hashcode non valide
appelScanner = false;

var token = '';
var tokenUnemcrypted = '';

$(document).ready(function()
{

	$("#copyright").html("&copy;"+dateCopyright) ;
	overlay.init();

	i18nGUI('fr');

	if(androidVersion >= 3)
	{
		for(var i=0;i<listeLangues.length;i++)
		{
			if(window.navigator.language.indexOf(listeLangues[i])!=-1)
			{
				i18nGUI(listeLangues[i]);
			}
		}
	}

	initApplication();


	//la methode permettant de recuperer la langue du telephone est appele dans la methode ondeviceready
	//la methode ondeviceready est executee apres la methode document.ready
	//on attends quele device soit pret avant de changer la langue par défaut
	/*setTimeout(function()
	{
		if (deviceLanguageSetting != '' && deviceLanguageSetting != currentLanguage)
		{
			i18nGUI(deviceLanguageSetting);
			changeLanguage(deviceLanguageSetting);
			fixHeaderBar(this);
		}
	}, 3000);*/
});


//Tous les échanges se font de manière synchrone avec le serveur
//Toute erreur ajax provoque un message d'erreur global
$.ajaxSetup({
		async: true,
	    crossDomain:true,
	    cache : false
});



$(document).ajaxError(function() {
	 afficherMessage($.i18n.prop('home.erreurAjax'));
	 $('#saisienumero #saisienumero-submit-bouton').removeClass('ui-disabled');
	 $('#choixpaiement').find('#boutonsReglement').find('.ui-btn-active').removeClass('ui-disabled');
	 $('#recapitulatif').find('#recapitulatif-submit-bouton').removeClass('ui-disabled');
	 $('#justificatif').find('#btn_telechargement').removeClass('ui-disabled');
	 overlay.hide();
});


//This should be removed for prod release remove this
/*
$(document).ajaxError(function( event, jqxhr, settings, thrownError ) {
	 // var msg = $.i18n.prop('home.erreurAjax');
	 //msg = msg + ':' + ' settings.url:' + settings.url + ' event:' + event + ' thrownError:' + thrownError + ' jqxhr:' + jqxhr;
	 afficherMessage('Error while trying to access:'
	 	+ settings.url
		+ '<br/>Error:' + thrownError
		+ '</br>Event:' + event
		+ '</br>jqxhr:<li>status:' + jqxhr.status + '</li>'
	  + '<li>statusText:' + jqxhr.statusText + '</li>'
	  + '<li>responseText:' + jqxhr.responseText + '</li>'
	  + '<li>readyState:' + jqxhr.readyState + '</li>');
	 $('#saisienumero #saisienumero-submit-bouton').removeClass('ui-disabled');
	 $('#choixpaiement').find('#boutonsReglement').find('.ui-btn-active').removeClass('ui-disabled');
	 $('#recapitulatif').find('#recapitulatif-submit-bouton').removeClass('ui-disabled');
	 $('#justificatif').find('#btn_telechargement').removeClass('ui-disabled');
	 overlay.hide();
});
*/

infosJustificatif = function(numeroTelepaiement, montant, dateReglement, numcb, numautorisation, referenceReglement, media, nouveauJustif)
{
	this.numeroTelepaiement = numeroTelepaiement;
	this.montant = montant;
	this.dateReglement = dateReglement;
	this.numcb = numcb;
	this.numautorisation = numautorisation;
	this.referenceReglement = referenceReglement;
	this.media = media;
	this.nouveauJustif = nouveauJustif;
}


//activation personnalisé du menu
setActiveMenu = function()
{
	//desactivation des menu de la barre de navigation
	$.mobile.activePage.find('footer').find('li').find('a').removeClass('ui-btn-active');
	if(mode=='paiement')
	{
		//activation 2è menu de la barre de navigation
		$.mobile.activePage.find('footer').find('li:eq(1)').find('a').addClass('ui-btn-active');
	}
	else
	{
		$.mobile.activePage.find('footer').find('li:eq(2)').find('a').addClass('ui-btn-active');
	}
}


//function de gestion de traitement des erreurs en retour du serveur
traiterRetourErreur = function(responseBean)
{
	if(responseBean.codeRetour == -1)
	{
		//gestion de l'affichage des erreurs techniques
		if(responseBean.messageBean.typeMessage == 'TECH')
		{
			$('#erreur #message').html(responseBean.messageBean.libelleMessage);
			$.mobile.changePage($('#erreur'));
		}

		if(responseBean.messageBean.typeMessage == 'METIER')
		{
			afficherMessage(responseBean.messageBean.libelleMessage);
		}

		if(responseBean.messageBean.typeMessage == 'VERSION')
		{
			afficherMessageVersion(responseBean.messageBean.libelleMessage);
			//navigator.app.exitApp();
		}

		if(responseBean.messageBean.typeMessage == 'TIMEOUT')
		{
			$.mobile.changePage($('#home'));
			//on affiche le message uniquement si le parametre afficherMessageTimeout est a true
			if(afficherMessageTimeout)
			{
				afficherMessage($.i18n.prop(responseBean.messageBean.libelleMessage));
			}
			afficherMessageTimeout = true;
			//on cache l'overlay (afficher par exemple au DemanderValidationSession lors du telechargement du justif)
			overlay.hide();

			//on demande un nouveau token apres une session expiree
			initApplication();
		}

		return false;
	}
}


//Gestion de la hauteur de l'entete et du scrolling
$('div[data-role="page"]').live('pageshow',function(event)
{
	fixHeaderBar(this);

	if(window.innerHeight < 500) {
		$('#home #home-logo-amendes img').css('padding-top', '2em');
	}

	/*if (androidVersion < 3) {
		var footer = $(this).find('.footer');
		if ($.mobile.activePage.is('#home'))
		{
			footer.css('position','fixed');
		}
		else
		{
			footer.css('position','');
		}
	}
	else
	{*/
		var footer = $(this).find('.footer');
//	}

	setTimeout(function()
	{
		hauteurDiv = $.mobile.activePage.height();
	},1000);
});


fixHeaderBar = function(page)
{
	$.mobile.defaultPageTransition="none";

	try
	{
		//cache current page being created and the id of the element that will be passed to iScroll
		//window.scrollTo(0,0);
		var $page = $(page);
		wrapper_id = page.id + '_wrapper';
		scroller_id = page.id + '_scroller';

		//only run the following code if the `.content` div exists on the page (which is the element that will be passed to iScroll)
		if ($page.find('.content').length > 0)
		{
            /*if (androidVersion < 3) {
            	var header = $(page).find('.header');
	            var footer = $(page).find('.footer');
	            var wrapper =$(page).find('.wrapper');
	            var scroller = $(page).find('.scroller');

	            var headerH = header.height();
	            var footerH = footer.height();
	            var wrapperH = window.innerHeight - headerH - footerH;
	            var scrollerH = scroller.height();

	            wrapper.css('height',wrapperH);

	            if(scrollerH < wrapperH)
	            {
	                scroller.css('height',wrapperH);
	            }
	            else
	            {
	              	scroller.css('height',wrapperH);
	                scroller.css('overflow','scroll');
	            }
            } else {*/
            	var header = $(page).find('.header');
	            var footer = $(page).find('.footer');

	            header.css('position','fixed');
	            //header.css('z-index','999999');

	            footer.css('position','fixed');
                //footer.css('z-index','900');
            	$('#'+wrapper_id).css('margin-top',$('.ui-page-active .header').height()+'px');
           // }
		}

		/*if(androidVersion < 3)
		{
			touchScroll("saisienumero_wrapper");touchScroll("FAQ_wrapper");touchScroll("recapitulatif_wrapper");touchScroll("justificatif_wrapper");touchScroll("aide-choixpaiement_wrapper");touchScroll("aide-justificatif_wrapper");touchScroll("saisiecb_wrapper");
		} */

	}catch(e)
	{
		console.error(e.message);
	}
}

function isTouchDevice() {
    try {
		document.createEvent("TouchEvent");
		return true;
    } catch(e) {
		return false;
    }
}

function touchScroll(id){
	if(isTouchDevice()){ //if touch events exist...
		var el=document.getElementById(id);
		var scrollStartPos=0;

		document.getElementById(id).addEventListener("touchstart", function(event) {
		scrollStartPos=this.scrollTop+event.touches[0].pageY;
		//event.preventDefault();
		},false);

		document.getElementById(id).addEventListener("touchmove", function(event) {
		this.scrollTop=scrollStartPos-event.touches[0].pageY;
		//event.preventDefault();
		},false);
	}
}

//fonction de vérification du type de donnée s'il est de format JSON
function isJSON(data) {
    var isJson = false
    try {
        // this works with JSON string and JSON object, not sure about others
       var json = $.parseJSON(data);
       isJson = typeof json === 'object' ;
    } catch (ex) {
        console.error('data is not JSON');
    }
    return isJson;
}

//fonction d'affichage d'erreur pour un message et élément donné
displayErrors = function(errorMessage,sourceElement)
{
	//on supprime les messages d'erreurs existants
	$(sourceElement).closest('div').next('p.errorMessage').remove();

	//On ajoute le message d'erreur après mon élément en question
	$(sourceElement).closest('div').after('<p class="errorMessage">'+errorMessage+'</p>');

	$(sourceElement).closest('div').removeClass('good');
	$(sourceElement).closest('div').addClass('error');
}

displayMessageError = function(errorMessage,sourceElement)
{
	//on supprime les messages d'erreurs existants
	$(sourceElement).closest('div').next('p.errorMessage').remove();

	//On ajoute le message d'erreur après mon élément en question
	$(sourceElement).closest('div').after('<p class="errorMessage">'+errorMessage+'</p>');
}

displaySourceElementError = function(sourceElement)
{
	$(sourceElement).closest('div').removeClass('good');
	$(sourceElement).closest('div').addClass('error');
}

confirmField = function(sourceElement)
{
	$(sourceElement).closest('div').removeClass('error');
	$(sourceElement).closest('div').addClass('good');
}


//internationalisation de l'application
i18nGUI = function(langue)
{
	try
	{

		changeHeader(langue);

		$.i18n.properties({
			name:'Message',
			path:'./i18n/',
			mode:'both',
			language:langue,
			callback: function() {

				//i18N des balises i18n
			   $('i18n').each(function()
			   {
		   			$(this).html($.i18n.prop($(this).attr('key')));
			   });

			   //i18n des placeholders
			   $('input').each(function()
			   {
				   var myPlaceHolderKey = $(this).attr('key');
				   if(myPlaceHolderKey)
				   {
					   if($.i18n.prop(myPlaceHolderKey))
						   $(this).attr('placeholder',$.i18n.prop(myPlaceHolderKey));
				   }
			   });

				 if ('fr' == langue)
				 {
					 $('.faqFpsm').show();
				 }
				 else
				 {
					 $('.faqFpsm').hide();
				 }

			}
		});
	}
	catch(e)
	{
		console.log(e.message);
		console.log(e.stack);
	}

	//affectation de la langue courante pour la traduction des message de type timeout
	currentLanguage = langue;

	//positionnement des images de la page d'accueil
    //lorsque la barre de menu est sur 2 lignes ou 1 seule
    if(currentLanguage == 'it' || currentLanguage == 'en')
    {
        $('#home #home-logos .blockGauche img').css('bottom', '5em');
        $('#home #home-logos .blockDroit img').css('bottom', '5em');
    }
    else
    {
        $('#home #home-logos .blockGauche img').css('bottom', '4em');
        $('#home #home-logos .blockDroit img').css('bottom', '4em');
    }

		if ('fr' == currentLanguage)
		{
			$('.faqFpsm').show();
		}
		else
		{
			$('.faqFpsm').hide();
		}
}



//fonction de formatage de numéro de télépaiement avec les tirets -
format_numero_telepaiement_with_hyphen = function(numero)
{
	var myNumero = numero.replace(/-/g,'');

	var myFormatedNumero = '';
	for(var i=1;i<=myNumero.length;i++)
	{
		myFormatedNumero = myFormatedNumero+myNumero[i-1];
		if(i%4==0 && i!=myNumero.length)
		{
			myFormatedNumero = myFormatedNumero+"-";
		}
	}

	return myFormatedNumero;
}



//fonction d'ouverture de lien propre à Android dans phonegap
openURL =  function(url) {
      navigator.app.loadUrl(url, {openExternal:true});
}

afficherMessage = function(message)
{
	$('#popupMessageErreur').remove();
	$('<div id="popupMessageErreur" data-role="popup" data-overlay-theme="a" class="ui-content" data-theme="d" data-position-to="window"><p style="font-size:10px">'+message+'</p></div>').popup().popup('open',{transition:'pop'}).click(function(){$(this).popup('close');});
}

afficherMessageVersion = function(message)
{
	$('#popupMessageErreurVersion').remove();
	$('<div id="popupMessageErreurVersion" data-role="popup" data-overlay-theme="a" class="ui-content" data-theme="d" data-position-to="window"><p style="font-size:16px">'+message+'</p></div>').popup().popup('open',{transition:'pop'}).click(function(){$(this).popup('close');navigator.app.exitApp();});
}


//fonction de formattage de nombre
formatNombre = function(valeur,decimal,separateur) {
	// formate un chiffre avec 'decimal' chiffres après la virgule et un separateur
		var deci=Math.round( Math.pow(10,decimal)*(Math.abs(valeur)-Math.floor(Math.abs(valeur)))) ;
		var val=Math.floor(Math.abs(valeur));
		if ((decimal==0)||(deci==Math.pow(10,decimal))) {val=Math.floor(Math.abs(valeur)); deci=0;}
		var val_format=val+"";
		var nb=val_format.length;

		// for (var i=1;i<4;i++) {
		//	if (val>=Math.pow(10,(3*i))) {
		//		val_format=val_format.substring(0,nb-(3*i))+separateur+val_format.substring(nb-(3*i));
		//	}
		//}
		if (decimal>0) {
			var decim="";
			for (var j=0;j<(decimal-deci.toString().length);j++) {decim+="0";}
			deci=decim+deci.toString();
			let decimalSep = ',';
			if (currentLanguage == 'en') {
				decimalSep = '.';
			}
				
			//val_format=val_format+separateur+deci;
			val_format=val_format+decimalSep+deci;
		}
		if (parseFloat(valeur)<0) {val_format="-"+val_format;}
		return val_format;
	}







overlay = {

		click_on_overlay_hide: true,

		show_loading_image: true,

		loading_image: "./images/spinner.gif",

		$: function(id){
			return document.getElementById(id);
		},

		init: function(){
			var ol_div = document.createElement("div");

			ol_div.id = "overlay";
			ol_div.style.display = "none";

			ol_div.onclick = (this.click_on_overlay_hide)? overlay.hide : null;

			if(this.show_loading_image){
				var l_img = document.createElement("img");

				l_img.src = this.loading_image;
				l_img.style.position = "absolute";
				l_img.style.top = ((((window.innerHeight)? window.innerHeight : document.body.clientHeight) / 2)-32) + "px";
				l_img.style.left = ((((window.innerWidth)? window.innerWidth : document.body.clientWidth) / 2)-32) + "px";

				ol_div.appendChild(l_img);
			}

			document.body.appendChild(ol_div);
		},

		show: function(){
			if(this.$("overlay")){
				this.$("overlay").style.height= hauteurDiv+"px";
				this.$("overlay").style.display = "";
			}
		},

		hide: function(){
			if(overlay.$("overlay")){
				overlay.$("overlay").style.display = "none";
			}
		}
	}


function changeHeader(langue)
{
	if (langue != 'fr')
	{
		changeHeaderEtranger();
	}
	else
	{
		changeHeaderFrancais();
	}
	changeSaisieNumero(langue);
}

function changeHeaderEtranger ()
{
   //on recupere tous les a des entetes
   $(".header > a").each(function()
   {
	   if($(this).hasClass('boutonFr'))
	   {
		   //on n'affiche pas les boutons français
		   $(this).hide();
	   }
	   else
	   {
		    //on affiche les boutons étranger
			$(this).show();
			$(this).css('float','left');
	   }
   });
   $("#saisienumero .header h1 i18n").removeClass('saisienumeroTitreFr').addClass('saisienumeroTitreEtr');
}

function changeHeaderFrancais()
{
	//on recupere tous les a des entetes
   $(".header > a").each(function()
   {
	   if($(this).hasClass('boutonFr'))
	   {
		    //on affiche les boutons français
			$(this).show();
			$(this).css('float','left');
	   }
	   else
	   {
		   //on n'affiche pas les boutons étranger
		   $(this).hide();
	   }
   });

   $("#saisienumero .header h1 i18n").removeClass('saisienumeroTitreEtr').addClass('saisienumeroTitreFr');
}

//Appel de vérification de conformité de l'application
function initApplication ()
{

	//utilise pour le load url
	$.mobile.allowCrossDomainPages = true;

	//utilise pour les appel ajax cross domain
	$.support.cors = true;

	fxName = 'DemanderValidationApplication';
	// setTimeout(function()
	//{
		//overlay.show();

	$.ajax({
	    url: host+"/DemanderToken",
	    type:'POST',
	    timeout: 10000,
	    dataType:"html",
	    crossDomain:true,
	    success:function(data, status)
	    {
	    	token=encrypt(data);
	    	tokenUnemcrypted = token;
			token = encodeURIComponent(token);

			//Validation de l'application par le serveur
			$.post(host+"/"+fxName,'DemanderValidationApplicationRequestBean={version:"'+myVersion+'",langue:"'+currentLanguage+'",navigateur:"'+myNavigateur+'",hashcode:"'+token+'"}').done(function(data)
			{
				//console.log("data = "+data);

				// overlay.hide();

				var myResult = $.parseJSON(data);

				traiterRetourErreur(myResult);

				if (myResult.afficherMentionSiPresent)
				{
					$('.titre1SiPresent').css('display','block !important');
					afficherMentionSiPresent = true;
				}
				else
				{
					$('.titre1SiPresent').css('display','none !important');
					afficherMentionSiPresent = false;
				}

				//changeLanguage(currentLanguage);
			});
	    },
	    error: function()
	    {
	    	//$(document).ajaxError est egalement appele, on supprime donc l'affichage du message serveur injoignable
	    	//afficherMessage($.i18n.prop('home.erreurAjax'));

	    	//on n'a pas reussi a contacter le serveur, par défaut, on n'affiche pas la mention si présent
	    	$('.titre1SiPresent').css('display','block  !important');
	    	afficherMentionSiPresent = false;
	    }
	});

	//},100);
}

function changeSaisieNumero(langue)
{
	if (langue == 'nl')
	{
		$('#saisienumero-boutons > div').removeClass('ui-block-b').addClass('ui-block-a').css('width','100%');
	}
	else
	{
		var nbDiv = 1;
		$('#saisienumero-boutons > div').each(function()
	    {
			$(this).css('width','50%');
			if(nbDiv == 2)
		    {
		    	$(this).removeClass('ui-block-a').addClass('ui-block-b');
		    }
		    nbDiv++;
	    });
	}
}

changeLanguage = function(langue)
{
	//RG TAM-IHM 0100.07.01
	//Amende considere comme etrangere si la langue est differente de fr
	if ('fr' == langue)
	{
		isAmendeEtrangere = false;
		$('.faqFpsm').show();
	}
	else
	{
		isAmendeEtrangere = true;
		$('.faqFpsm').hide();
	}

	overlay.show();


	/*$.post(host+"/DemanderToken").done(function(data)
	{
		var token=encrypt(data);
		token = encodeURIComponent(token);*/

		$.post(host+"/DemanderChangementLangue",'DemanderChangementLangueRequestBean={langue:"'+langue+'",navigateur:"'+myNavigateur+'",hashcode:"'+token+'"}').done(function(data)
		{
			overlay.hide();

			var myResult = $.parseJSON(data);

			traiterRetourErreur(myResult);

			$.mobile.changePage($('#home'));
		});
	//});

}
