/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
var app = {
    // Application Constructor
    initialize: function() {
        this.bindEvents();
    },
    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
        document.addEventListener('resume', this.verifSessionAlive, false);
        document.addEventListener('backbutton', this.actionnerBoutonRetour, false);
    },
    onDeviceReady: function() {

    },
    verifSessionAlive: function() {
    if(!appelScanner)
    	{
    		applicationOnPause = false;
    		/*$.post(host+"/DemanderToken").done(function(data)
    		{
    			var token=encrypt(data);
    			token = encodeURIComponent(token);*/

            $.post(host+'/DemanderValidationSession','DemanderValidationSessionRequestBean={navigateur:"'+myNavigateur+'",hashcode:"'+token+'"}').done(function(data)
            {
                var myResult = $.parseJSON(data);
                afficherMessageTimeout = false;
                traiterRetourErreur(myResult);
            });

    		//});
    	}
    	else
    	{
    		appelScanner = false;
    	}
    },
    checkLanguage: function() {
        navigator.globalization.getPreferredLanguage(
            function (language) {
                var lang = language.value.split("-");
                if(lang[0] != currentLanguage) {
                    deviceLanguageSetting = lang[0];
                }
            },
            function () {
                console.log('Error getting language');
            }
        );
    },
    actionnerBoutonRetour: function(e) {

        if($.mobile.activePage.is('#home')){
           e.preventDefault();

           if($('.ui-simpledialog-container').length==0)
           {
               $('<div>').simpledialog2({
                    mode: 'button',
                    headerClose: false,
                    buttonPrompt: $.i18n.prop('home.libelle_quitter'),
                    buttons : {
                      'Quitter': {
                        click: function () {
                            //navigator.app.exitApp();
                            navigator.app.exitApp();
                        }
                      },
                      'Annuler': {
                        click: function () {

                        },
                        icon: "delete",
                        theme: "c"
                      }
                    }
                  });

               //traduction des boutons de la popup
               $('.ui-simpledialog-controls .ui-btn-text:eq(0)').html($.i18n.prop('home.boutonQuitter'));
               $('.ui-simpledialog-controls .ui-btn-text:eq(1)').html($.i18n.prop('home.boutonAnnuler'));
           }
       }
       else {
            e.preventDefault();
               //Confusion entre les back de navigateur et back bouton Android, on set la mani�re de revenir � la main pour �tre sur

           //console.log($.mobile.activePage.attr('id'));

               if($.mobile.activePage.is('#choixpaiement'))
                   $.mobile.changePage($('#saisienumero'));

               if($.mobile.activePage.is('#saisiecb'))
               {
                    if(amendeConsignable)
                    {
                        $.mobile.changePage($('#choixpaiement'));
                    }
                    else
                    {
                        $.mobile.changePage($('#saisienumero'));
                    }
               }

               if($.mobile.activePage.is('#recapitulatif'))
                   $.mobile.changePage($('#saisiecb'));

               if($.mobile.activePage.is('#aide-saisienumero'))
                   $.mobile.changePage($('#saisienumero'));

               if($.mobile.activePage.is('#aide-choixpaiement'))
                   $.mobile.changePage($('#choixpaiement'));

               if($.mobile.activePage.is('#aide-saisiecb'))
                   $.mobile.changePage($('#saisiecb'));

               if($.mobile.activePage.is('#aide-justificatif'))
                   $.mobile.changePage($('#justificatif'));

               if($.mobile.activePage.is('#mentions-legales'))
                   $.mobile.changePage($('#home'));

               if($.mobile.activePage.is('#justificatif-courriel'))
                   $.mobile.changePage($('#justificatif'));
       }
       app.checkLanguage();
    }
};

app.initialize();