$('#justificatif').live('pageshow',function()
{
	fillJustificatifFields(infosPourJustificatif);
	setActiveMenu();

	//on reactive le bouton d'envoi d'email
	$('#justificatif-courriel-submit-bouton').removeClass('ui-disabled');

	//traduction du bouton de téléchargement

	//on remplace les textes en fonction si l'amende est payé ou pas
	if(amende_paye)
	{
		$('#justificatif h1.ui-title').text($.i18n.prop('justificatif.titreJustificatif'));
		$('#justificatif #infosreglement h3 .ui-btn-text').text($.i18n.prop('justificatif.bloc.titreJustificatif'));
	}
	else
	{
		$('#justificatif h1.ui-title').text($.i18n.prop('justificatif.titreConfirmation'));
		$('#justificatif #infosreglement h3 .ui-btn-text').text($.i18n.prop('justificatif.bloc.titreConfirmation'));
	}

	function action()
	{
		if(mode=='consignation' && infosPourJustificatif.nouveauJustificatif)
		  {

				if(amende_afm)
				{
					$('#popupJustificatifConsignationAfm').popup('open',{transition:'pop'});

					$('#popupJustificatifConsignationAfm').click(function(){
							$(this).popup('close');
					});
				}
				else
				{
					$('#popupJustificatifConsignation').popup('open',{transition:'pop'});

					$('#popupJustificatifConsignation').click(function(){
							$(this).popup('close');
					});
				}


				mode='paiement';
		  }
	}

	setTimeout(action, 1000);
}
);

fillJustificatifFields = function(myJustifInfos)
{
	$.mobile.activePage.find('#numero-telepaiement-value').html(format_numero_telepaiement_with_hyphen(myJustifInfos.numeroTelepaiement));
	$.mobile.activePage.find('#montant-value').html(formatNombre(myJustifInfos.montant,2,',')+' &euro;');
	$.mobile.activePage.find('#date-reglement-value').html(myJustifInfos.dateReglement);
	$.mobile.activePage.find('#numero-carte-bancaire-value').html(format_numero_telepaiement_with_hyphen(myJustifInfos.numeroCarteBancaire));
	$.mobile.activePage.find('#numero-autorisation-value').html(myJustifInfos.numeroAutorisation);
	$.mobile.activePage.find('#ref-reglement-value').html(myJustifInfos.referenceReglement);

	if(myJustifInfos.nouveauJustificatif)
	{
		if(mode == 'paiement')
			$.mobile.activePage.find('.info').html($.i18n.prop('justificatif.introConfirmationPaiement'));

		if(mode == 'consignation')
			$.mobile.activePage.find('.info').html($.i18n.prop('justificatif.introConfirmationConsignation'));
	}
	else
	{
		if(myJustifInfos.media=='SVI')
			$.mobile.activePage.find('.info').html($.i18n.prop('justificatif.introJustificatifSVI'));

		if(myJustifInfos.media=='TAI')
			$.mobile.activePage.find('.info').html($.i18n.prop('justificatif.introJustificatifTAI'));

		if(myJustifInfos.media=='TAM')
			$.mobile.activePage.find('.info').html($.i18n.prop('justificatif.introJustificatifTAM'));
	}
}

//Click du bouton pour l'envoi de mail
$('#justificatif-courriel-submit-bouton').live('click',function()
{
	var numeroTelepaiement = $('#justificatif').find('#numero-telepaiement-value').html();
	var email = $('#courriel').val();

	//on supprime tout message apparant d'erreur
	$.mobile.activePage.find('p.errorMessage').remove();

	//RG TAM-IHM 0200.01.01
	var reg = new RegExp('^[a-z0-9]+([_|\.|-]{1}[a-z0-9]+)*@[a-z0-9]+([_|\.|-]{1}[a-z0-9]+)*[\.]{1}[a-z]{2,6}$', 'i');

	if(reg.test(email))
	{
		overlay.show();
		/*$.post(host+"/DemanderToken").done(function(data)
		{
			var token=encrypt(data);
			token = encodeURIComponent(token);*/
			fxName='DemanderJustificatifEMail';

			$.post(host+"/"+fxName,'DemanderJustificatifEmailRequestBean={numeroTelepaiement:"'+numeroTelepaiement+'",eMail:"'+email+'",navigateur:"'+myNavigateur+'",hashcode:"'+token+'"}').done(function(data)
			{
				overlay.hide();
				var myResult = $.parseJSON(data);
				traiterRetourErreur(myResult);

				//mail envoyé
				if(myResult.codeRetour==0)
				{
					$('#justificatif-courriel-info').html($.i18n.prop('justificatif.email.confirmation'));
					$('#justificatif-courriel-submit-bouton').addClass('ui-disabled');
					$('#courriel').closest('div').removeClass('error');

					setTimeout(function()
					{
						$.mobile.changePage($('#justificatif'));
					},3000);
				}
			});
		//});
	}
	else
	{
		displayErrors($.i18n.prop('justificatif.email.adresseInvalide'),$('#courriel'));
	}
});



//définition du comportement du bouton téléchargement
$('#btn_telechargement').live('click',telechargerJustifPDF);

function telechargerJustifPDF() {
	overlay.show();

		$.post(host+"/DemanderValidationSession",'DemanderValidationSessionRequestBean={navigateur:"'+myNavigateur+'",hashcode:"'+token+'"}').done(function(data)
		{
			var myResult = $.parseJSON(data);
			afficherMessageTimeout = true;
			traiterRetourErreur(myResult);

			if(myResult.codeRetour == 0)
			{
				//téléchargement du justificatif
				var remoteFile =  host+'/DemanderTelechargementJustif?DemanderTelechargementJustifRequestBean={navigateur:"'+myNavigateur+'",hashcode:"'+tokenUnemcrypted+'",numeroTelepaiement:"'+numeroTelepaiement.replace(/-/g,'')+'"}';
				var remoteFileEncodeURI = encodeURI(remoteFile);
				remoteFileEncodeURI = remoteFileEncodeURI.replace(/\+/g, '%2B');

					var localDirectoryName = cordova.file.externalRootDirectory + 'download/';

					if(androidVersion < 3) {
						localDirectoryName = cordova.file.externalDataDirectory;
						if(localDirectoryName == null ) {
							localDirectoryName = cordova.file.applicationStorageDirectory;
						}
					}

				var localFileName = 'justificatif_'+ format_numero_telepaiement_with_hyphen(numeroTelepaiement) + '.pdf';

					window.resolveLocalFileSystemURL(localDirectoryName, function(dir) {
					dir.getFile(localFileName, {create:true, exclusive: false}, function(file) {
						var localPath = file.toURL();
									if (device.platform === "Android" && localPath.indexOf("file://") === 0) {
											localPath = localPath.substring(7);
									}

									var ft = new FileTransfer();
									ft.download(
												remoteFileEncodeURI,
											localPath,
											function(entry) {
														cordova.plugins.fileOpener2.open(entry.toURL(),
																	'application/pdf',
																	{
																			error : function(e) {
																					console.log('Error status: ' + e.status + ' - Error message: ' + e.message);
																			},
																			success : function () {
																					console.log('file opened successfully');
																			}
																	}
														);
													overlay.hide();
										},
										function(error) {
														overlay.hide();
												}
								, true);
					}, fail);
				}, fail);
			}

			$('#btn_telechargement').removeClass('ui-disabled');
		});

}


//fonction handle d'echec sur un evenement
function fail(evt) {
    console.log(evt);
}
