amende_afm=false;
amende_afm_ca=false;
amende_paye=false;
valider_formulaire=false;
reset_formulaire=true;
var webview = undefined;


//Appel au scanner
$('#img_photo').live('click',function()
{
	appelScanner = true;
	cordova.plugins.barcodeScanner.scan( function(result)
	{
		if(result.text.length!=0)
		{
			if(result.text.length!=16 && result.text.length!=20)
			{
				afficherMessage($.i18n.prop('saisienumero.libelle_scanInvalide'));
			}
			else
			{
				var numero = result.text.substring(0,result.text.length-2);
				var cle = result.text.substring(result.text.length-2,result.text.length);

				reset_form();

				$('#numero-telepaiement').val(format_numero_telepaiement_with_hyphen(numero));
				$('#cle-numero-telepaiement').val(cle);

				//soumission du formulaire
				valider_formulaire = true;
				check();
			}
		}
	},
	function(error)
	{
		afficherMessage($.i18n.prop('saisienumero.error_scan'));
	});
});


//Validation du formulaire de saisie de numéro de télépaiement
check = function()
{
	if (valider_formulaire)
	{
		try
		{
			amende_paye=false;
			fxName = "DemanderAmendeReglable";

			//Vérification si les données sont conformes
			if(check_form_values())
			{
				submitAndTreatDemanderAmendeReglable();
			}
		}
		catch(e)
		{
			console.error(e.message);
		}
	}
	valider_formulaire=false;
}

submitAndTreatDemanderAmendeReglable = function()
{
	$('#saisienumero-submit-bouton').addClass('ui-disabled');
	overlay.show();

	/*$.post(host+"/DemanderToken").done(function(data)
	{
		var token=encrypt(data);
		token = encodeURIComponent(token);*/
		// $.post(host+"/"+fxName,'DemanderAmendeReglableRequestBean={numeroTelepaiement:"'+$('#numero-telepaiement').val().replace(/-/g,'')+'",cle:"'+$('#cle-numero-telepaiement').val()+'",navigateur:"'+myNavigateur+'",hashcode:"'+token+'"}').done(function(data)
		submitDemanderAmendeReglable($('#numero-telepaiement').val().replace(/-/g,''), $('#cle-numero-telepaiement').val(), function(data)
		{
			$('#saisienumero-submit-bouton').removeClass('ui-disabled');
			overlay.hide();
			console.log(data);

			var myResult = $.parseJSON(data);

			traiterRetourErreur(myResult);

			//set de paramètres en fonction du numéro saisi
			amende_afm = $('#numero-telepaiement').val().length==22 || $('#numero-telepaiement').val().length==18;
			amende_afm_ca = $('#numero-telepaiement').val().indexOf('0350-50') == 0 || $('#numero-telepaiement').val().indexOf('035050') == 0;
			isAmendeEtrangere = currentLanguage != 'fr' || myResult.acoEtranger;
			numeroTelepaiement = $('#numero-telepaiement').val();

			//amende payable et consignable
			if(myResult.codeRetour == 0)
			{
				amendeConsignable = true;
				$.mobile.changePage($('#choixpaiement'));
			}

			//on supprime toute page de saisie cb
			$.mobile.pageContainer.find('#saisiecb').remove();

			//amende payble uniquement SIPS1
			if(myResult.codeRetour == 1)
			{
				mySaisieCBInfos = myResult.saisieCBInfos;
				mode='paiement';

				$.get(host+'/saisieCB/saisieCBAndroidVersion.jsp').success(function(data)
				{
					//on rajoute la page de saisie cb au dom actuel
					$(data).appendTo($.mobile.pageContainer);

					// on remplace les boutons de l'entete
					changeHeader(currentLanguage);

					amendeConsignable = false;

					//Changement du libelle du montant de l'amende selon les cas
					$('i18n[key="saisiecb.bloc_informations.libelle_montant"]').html(mySaisieCBInfos.libelleMontant);

					//Changement du libelle date infraction selon les cas.
					$('i18n[key="saisiecb.bloc_informations.libelle_dateInfraction"]').html(myResult.saisieCBInfos.libelleDateInfraction);
					// Pour compatibilité entre serveur et versions antérieures du client, on masque le label date infraction destinees aux version precedentes et on affiche le nouveau
					$('#saisiecb #date-infraction-label').hide();
					$('#saisiecb #date-infraction-label2').removeAttr('hidden');

					//on initialise les valeurs du bloc d'informations de saisiecb
					$('#saisiecb #numero-telepaiement-value').html(format_numero_telepaiement_with_hyphen(mySaisieCBInfos.numeroTelepaiement));
					$('#saisiecb #date-infraction-value').html(mySaisieCBInfos.dateInfraction);
					$('#saisiecb #date-avis-value').html(mySaisieCBInfos.dateAvis);
					$('#saisiecb #montant-amande-value').html(formatNombre(mySaisieCBInfos.montant,2,',')+' &euro;');

					// on initialise la liste des années
					anneEnCours = new Date().getFullYear();
					for (i = 0; i <= 10; i++) {
						$('#saisiecb #annee').append('<option value='+anneEnCours+'>'+anneEnCours+'</option>');
						anneEnCours = anneEnCours + 1;
					}

					// on initialise le mois en cours
					var moisEnCours = new Date().getMonth()+1;
					var value = '00';
					if(moisEnCours < 10) {
						value = '0'+moisEnCours;
					} else {
						value = moisEnCours;
					}
					$('#saisiecb #mois option[value='+value+']').attr("selected", "selected");

					$.mobile.changePage($('#saisiecb'));
				});
			}

			//amende déjà payé par un canal tout publie (TAI/SVI/TAM)
			if(myResult.codeRetour == 2)
			{
				amende_paye=true;
				//construction de l'objet de justificatif
				infosPourJustificatif =
					{
						numeroTelepaiement:format_numero_telepaiement_with_hyphen(myResult.justificatif.numeroTelepaiement),
						montant:myResult.justificatif.montant,
						dateReglement:myResult.justificatif.dateReglement,
						numeroCarteBancaire:myResult.justificatif.numeroCarteBancaire,
						numeroAutorisation:myResult.justificatif.numeroAutorisation,
						referenceReglement:myResult.justificatif.referenceReglement,
						media:myResult.justificatif.media,
						nouveauJustificatif:false
					}
				$.mobile.changePage($('#justificatif'));
			}

			// amende payable SIPS2
			if(myResult.codeRetour == 3)
			{
				mySaisieCBInfos = myResult.saisieCBInfos;
				mode='paiement';
				isPayableSips2 = true;

				amendeConsignable = false;

				//Changement du libelle du montant de l'amende selon les cas
				$('i18n[key="saisiecb.bloc_informations.libelle_montant"]').html(mySaisieCBInfos.libelleMontant);

				//Changement du libelle date infraction selon les cas.
				$('i18n[key="saisiecb.bloc_informations.libelle_dateInfraction"]').html(myResult.saisieCBInfos.libelleDateInfraction);

				//on initialise les valeurs du bloc d'informations de saisiecb
				$('#paiementsips2 #numero-telepaiement-value').html(format_numero_telepaiement_with_hyphen(mySaisieCBInfos.numeroTelepaiement));
				$('#paiementsips2 #date-infraction-value').html(mySaisieCBInfos.dateInfraction);
				$('#paiementsips2 #date-avis-value').html(mySaisieCBInfos.dateAvis);
				if (mySaisieCBInfos.natureInfraction && !('' == mySaisieCBInfos.natureInfraction)) {
					
					$('#paiementsips2 #nature-infraction').show();
					$('#paiementsips2 #nature-infraction-value').html(mySaisieCBInfos.natureInfraction);
				}
				else {
					$('#paiementsips2 #nature-infraction').hide();
				}
				$('#paiementsips2 #montant-amande-value').html(formatNombre(mySaisieCBInfos.montant,2,',')+' &euro;');

				$.mobile.changePage($('#paiementsips2'));
			}

		});
}

function submitDemanderAmendeReglable(numero, cle, callback) {
	fxName = "DemanderAmendeReglable";
	$.post(host + "/" + fxName,'DemanderAmendeReglableRequestBean={numeroTelepaiement:"' + numero + '",cle:"' + cle + '",navigateur:"' + myNavigateur + '",hashcode:"' + token + '"}').done(callback);
}

function check_form_values()
{
	return check_form_values_syntax();
}

function check_numero_value_syntax()
{
	//on enlève les messages d'erreurs actuels propres au numéro de télépaiement
	$('#numero-telepaiement').closest('div').next('p.errorMessage').remove();

	var monNumeroTelepaiement = $('#numero-telepaiement').val().replace(/-/g,'');
	var myNumeroError = '';
	isGood = true;

	// RG TAM-IHM 0100.01.01 : le numero de telepaiement ne doit pas être vide
	if("" == monNumeroTelepaiement)
	{
		myNumeroError = $.i18n.prop('saisienumero.error_rg0101');
		isGood = false;
	}
	else

	// RG TAM-IHM 0100.01.03 : le numero de telepaiement ne doit contenir que des chiffres
	if(!(monNumeroTelepaiement.match(/^[0-9]+$/) && (monNumeroTelepaiement.length==14 || monNumeroTelepaiement.length==18)))
	{
		myNumeroError = $.i18n.prop('saisienumero.error_rg0103');
		isGood = false;
	}
	else

	//RG TAM-IHM 0100.01.06 : un numéro de télépaiement de 14 chiffres doit se terminer par 1 ou 2
	if(monNumeroTelepaiement.length==14 && monNumeroTelepaiement.substring(monNumeroTelepaiement.length-1,monNumeroTelepaiement.length)!='1' && monNumeroTelepaiement.substring(monNumeroTelepaiement.length-1,monNumeroTelepaiement.length)!='2')
	{
		myNumeroError = $.i18n.prop('saisienumero.error_rg0106');
		isGood = false;
	}

	//RG TAM-IHM 0100.01.15 : un numéro de télépaiement de 14 chiffres doit commencer par 333
	//Cette regla a ete ajoutée suite au retour de recette du 28/08/2014, mais ne figure pas dans les DSFD
	if(monNumeroTelepaiement.length==14 && monNumeroTelepaiement.substring(0,3)!='333')
	{
		myNumeroError = $.i18n.prop('saisienumero.error_rg0115');
		isGood = false;
	}

	if(!isGood)
		displayErrors(myNumeroError,$('#numero-telepaiement'));
	else
		confirmField($('#numero-telepaiement'));

	return isGood;
}


function check_cle_value_syntax()
{
	//on enlève les messages d'erreurs actuels propres à la clé
	$('#cle-numero-telepaiement').closest('div').next('p.errorMessage').remove();

	var monNumeroTelepaiement = $('#numero-telepaiement').val().replace(/-/g,'');
	var maCleNumeroTelepaiement = $('#cle-numero-telepaiement').val();
	var myCleError = '';
	isGood = true;

	// RG TAM-IHM 0100.01.02 : la clé du numero de telepaiement ne doit pas etre vide
	if("" == maCleNumeroTelepaiement)
	{
		myCleError = $.i18n.prop('saisienumero.error_rg0102');
		isGood = false;
	}
	else
	// RG TAM-IHM 0100.01.04 : le numero de telepaiement ne doit contenir que des chiffres
	if(!maCleNumeroTelepaiement.match(/^[0-9]{2}$/))
	{
		myCleError = $.i18n.prop('saisienumero.error_rg0104');
		isGood = false;
	}
	else
	// RG TAM-IHM 0100.01.05 : La clé doit être le modulo 97 du numéro de télépaiement
	if(!testCoherence(monNumeroTelepaiement,maCleNumeroTelepaiement))
	{
		myCleError = $.i18n.prop('saisienumero.error_rg0105');
		isGood = false;
	}

	if(!isGood)
		displayErrors(myCleError,$('#cle-numero-telepaiement'));
	else
		confirmField($('#cle-numero-telepaiement'));

	return isGood;
}


function check_form_values_syntax()
{
	var isGood = check_numero_value_syntax();
	isGood =  check_cle_value_syntax() && isGood;
	return isGood;
}


//fonction de réinitialisation de formulaire (style + messages d'erreurs)
reset_form = function()
{
	//on enlève les message d'erreurs syntaxiques
	$('.errorMessage').remove();

	$('#saisienumero-form')[0].reset();

	$('#numero-telepaiement').closest('div').removeClass('error');
	$('#numero-telepaiement').closest('div').removeClass('good');
	$('#errorNumero span').empty();

	$('#cle-numero-telepaiement').closest('div').removeClass('error');
	$('#cle-numero-telepaiement').closest('div').removeClass('good');
	$('#errorCle span').empty();

	toggle_saisie();

	$('#saisienumero-submit-bouton').removeClass('ui-disabled');
}


$('#saisienumero').live('pageshow',function()
{

	setActiveMenu();

	//on reinitialise le formulaire sauf si on vient de la page d'aide
	if (reset_formulaire)
	{
		reset_form();
	}
	else // on vient de la page d'aide
	{
		reset_formulaire = true;
	}

	//permet de gerer le cas ou l'utilisateur a cliquer sur l'onglet payer ou consigner
	//avant d'avoir reçu la réponse du serveur
	if (afficherMentionSiPresent)
	{
		$('.titre1SiPresent').css('display','block !important');
	}
	else
	{
		$('.titre1SiPresent').css('display','none !important');
	}

	$('#numero-telepaiement').live('keyup',keyup_numerotelepaiement);
	$('#saisienumero-form').live('reset',toggle_saisie);


	$('#numero-telepaiement').live('blur',function()
	{
		if($('#numero-telepaiement').val().length!=0)
			check_numero_value_syntax();

		setTimeout(function () {
			afficherFooter();
		},300);
	});

	$('#cle-numero-telepaiement').live('blur',function()
	{
		if($('#cle-numero-telepaiement').val().length!=0)
			check_cle_value_syntax();

		setTimeout(function () {
			afficherFooter();
		},300);
	});

	document.onkeyup=function(e) {
		if(e.which == 13){
	    	$(document.activeElement).blur();
	    	$('.footer').show();
	    }
	}

    //on change la taille de hauteur de ligne du header de la page de saisie du numero de telepaiement
    //car en DE, le titre est sur 2 lignes
    if ('de' == currentLanguage)
    {
	    $("#saisienumero .header .ui-title").css('line-height','11px');
	    fixHeaderBar(this);
    }
    else
    {
	    $("#saisienumero .header .ui-title").css('line-height','25px');
	    fixHeaderBar(this);
    }
});


keyup_numerotelepaiement = function () {
	toggle_saisie();
	if ($('#numero-telepaiement').val().length >= parseInt($('#numero-telepaiement').attr('maxlength'))) {
		$('#cle-numero-telepaiement').focus().tap();
	}
}


toggle_saisie = function()
{
	let length = 18;
	let v = $('#numero-telepaiement').val();
	if(v.substring(0,3)==='333')
	{
		if (androidVersion >= 3) {
			length = 17;
		} else {
			length = 14;
		}
	}
	else
	{
		if (androidVersion >= 3) {
			length = 22;
		} else {
			length = 18;
		}
	}

	let lengths = '' + length;
	$('#numero-telepaiement').attr('maxlength',lengths);
	$('#numero-telepaiement').attr('size',lengths);

	// on formatte le numero uniquement si la version d'android utilisee est superieur ou egale a 3
	if (androidVersion >= 3) {
		format_numero_telepaiement();
	}
}


format_numero_telepaiement = function()
{
	var myNumero = $('#numero-telepaiement').val();
	myNumero = myNumero.replace(/-/g,'');
	myNumero = myNumero.replace(/ /g,'');

	var myFormatedNumero = '';
	for(var i=1;i<=myNumero.length;i++)
	{
		myFormatedNumero = myFormatedNumero+myNumero[i-1];
		if(i%4==0 && i!=myNumero.length)
		{
			myFormatedNumero = myFormatedNumero+"-";
		}
	}

	$('#numero-telepaiement').val(myFormatedNumero);
}





$('#numero-telepaiement,#cle-numero-telepaiement').live('focus',function()
{
	viderEtReinitialiserLeChampActif();
	$('.footer').hide();
});

function setFlag() {
	valider_formulaire = true;
}

function validerFormulaire()
{
	setTimeout(function () {
		$('.footer').show();

		if (valider_formulaire)
		{
			check();
		}

	},500);
}

function afficherFooter()
{
	if ('numero-telepaiement' != $(document.activeElement).attr('id') && 'cle-numero-telepaiement' != $(document.activeElement).attr('id'))
	{
		$('.footer').show();
	}
}

//on vide le champ avant de remettre la même donnée
//permet de résoudre le pb rencontré sur le galaxy S3 :
//présence d'un encadré n'affichant pas toujours l'intégralité de la valeur du champ
//BUG 9 du cahier de recette de PREPROD
function viderEtReinitialiserLeChampActif()
{
	var id = $(document.activeElement).attr('id');
	var valeur = $("#"+id).val();
	$("#"+id).val('');
	setTimeout(function() {
		$("#"+id).val(valeur);
	}, 50);
}
