$('#choixpaiement').live('pageshow',function()
{
	setActiveMenu();

	// surlignage du bouton correspondant au choix de type de règlement
	$(this).find('#boutonsReglement').find('a').removeClass('ui-btn-active');

	if(mode == 'paiement')
	{
		$(this).find('#boutonsReglement').find('a:eq(0)').addClass('ui-btn-active');
	}
	else
	{
		$(this).find('#boutonsReglement').find('a:eq(1)').addClass('ui-btn-active');
	}

	// on set le numéro de télépaiement en fonction de celui saisi
	$(this).find('#numero-telepaiement-value').html(format_numero_telepaiement_with_hyphen(numeroTelepaiement));


	//affichage sur 2 lignes du libelle du bouton de consignation lorsque la largeur de l'ecran est <= 320
	if(window.innerWidth <= 320)
	{
		$('#boutonsReglement .ui-btn-inner').css('white-space', 'normal');
	}


});

$('#boutonsReglement').find('a').click(function()
{
	$(this).addClass('ui-btn-active');

	// click sur le bouton payer
	if($(this).html()==$(this).closest('#boutonsReglement').find('a:eq(0)').html())
		mode='paiement';

	// click sur le bouton consigner
	if($(this).html()==$(this).closest('#boutonsReglement').find('a:eq(1)').html())
		mode='consignation';

	//RG TAM-IHM 0100.02.03
	if(mode=='paiement' && numeroTelepaiement.substring(numeroTelepaiement.length-1,numeroTelepaiement.length)=='2')
	{
		$('<div>').simpledialog2({
    	    mode: 'button',
    	    headerClose: false,
    	    buttonPrompt: $.i18n.prop('choixpaiement.confirmer_paiement'),
    	    buttons : {
    	      'Confirmer': {
    	        click: function () {
    	        	confirmerTypeReglement();
    	        }
    	      },
    	      'Annuler': {
    	        click: function () {
    	        },
    	        icon: "delete",
    	        theme: "c"
    	      }
    	    }
    	  });

		 //traduction des boutons de la popup
		$('.ui-simpledialog-controls .ui-btn-text:eq(0)').html($.i18n.prop('choixpaiement.boutonConfirmer'));
        $('.ui-simpledialog-controls .ui-btn-text:eq(1)').html($.i18n.prop('choixpaiement.boutonAnnuler'));


	}
	else
	//RG TAM-IHM 0100.02.04
	if(mode=='consignation' && numeroTelepaiement.substring(numeroTelepaiement.length-1,numeroTelepaiement.length)=='1')
	{
		$('<div>').simpledialog2({
    	    mode: 'button',
    	    headerClose: false,
    	    buttonPrompt: $.i18n.prop('choixpaiement.confirmer_consignation'),
    	    buttons : {
    	      'Confirmer': {
    	        click: function () {
    	        	confirmerTypeReglement();
    	        }
    	      },
    	      'Annuler': {
    	        click: function () {
    	        },
    	        icon: "delete",
    	        theme: "c"
    	      }
    	    }
    	  });

		 //traduction des boutons de la popup
		$('.ui-simpledialog-controls .ui-btn-text:eq(0)').html($.i18n.prop('choixpaiement.boutonConfirmer'));
        $('.ui-simpledialog-controls .ui-btn-text:eq(1)').html($.i18n.prop('choixpaiement.boutonAnnuler'));
	}
	else
	{
		confirmerTypeReglement();
	}


});


confirmerTypeReglement = function()
{
	$.mobile.activePage.find('#boutonsReglement').find('.ui-btn-active').addClass('ui-disabled');
	overlay.show();


	fxName='DemanderChoixTypeReglement';
	/*$.post(host+"/DemanderToken").done(function(data)
	{
		var token=encrypt(data);
		token = encodeURIComponent(token);*/
		$.post(host+"/"+fxName,'DemanderChoixTypeReglementRequestBean={typeReglement:"'+mode+'",navigateur:"'+myNavigateur+'",hashcode:"'+token+'"}').done(function(data)
		{
			$.mobile.activePage.find('#boutonsReglement').find('.ui-btn-active').removeClass('ui-disabled');
			overlay.hide();

			//console.log(data);

			var myResult = $.parseJSON(data);

			traiterRetourErreur(myResult);

			$.mobile.pageContainer.find('#saisiecb').remove();

			// Amende reglable SIPS1
			if(myResult.codeRetour == 0)
			{
				$.get(host+'/saisieCB/saisieCBAndroidVersion.jsp').success(function(data)
				{
					// on rajoute la page de saisie cb au dom actuel
					$(data).appendTo($.mobile.pageContainer);

					// on remplace les boutons de l'entete
					changeHeader(currentLanguage);

					//Changement du libelle du montant de l'amende selon les cas
					$('i18n[key="saisiecb.bloc_informations.libelle_montant"]').html(myResult.saisieCBInfos.libelleMontant);

					//Changement du libelle date infraction selon les cas.
					$('i18n[key="saisiecb.bloc_informations.libelle_dateInfraction"]').html(myResult.saisieCBInfos.libelleDateInfraction);


					// on initialise les valeurs du bloc d'informations de
					// saisiecb
					$('#saisiecb #numero-telepaiement-value').html(format_numero_telepaiement_with_hyphen(myResult.saisieCBInfos.numeroTelepaiement));
					$('#saisiecb #date-infraction-value').html(myResult.saisieCBInfos.dateInfraction);
					$('#saisiecb #date-avis-value').html(myResult.saisieCBInfos.dateAvis);
					$('#saisiecb #montant-amande-value').html(formatNombre(myResult.saisieCBInfos.montant,2,',')+' &euro;');

					// on initialise la liste des années
					anneEnCours = new Date().getFullYear();
					for (i = 0; i <= 10; i++) {
						$('#saisiecb #annee').append('<option value='+anneEnCours+'>'+anneEnCours+'</option>');
						anneEnCours = anneEnCours + 1;
					}

					// on initialise le mois en cours
					var moisEnCours = new Date().getMonth()+1;
					var value = '00';
					if(moisEnCours < 10) {
						value = '0'+moisEnCours;
					} else {
						value = moisEnCours;
					}
					$('#saisiecb #mois option[value='+value+']').attr("selected", "selected");




					$.mobile.changePage($('#saisiecb'));
				});
			}
			else if (myResult.codeRetour == 1) {
				// FIXME
				console.log("Amende consignable reglable en SIPS2")
				// Amende reglable SIPS2
				mySaisieCBInfos = myResult.saisieCBInfos;
				isPayableSips2 = true;

				//Changement du libelle du montant de l'amende selon les cas
				$('i18n[key="saisiecb.bloc_informations.libelle_montant"]').html(mySaisieCBInfos.libelleMontant);

				//Changement du libelle date infraction selon les cas.
				$('i18n[key="saisiecb.bloc_informations.libelle_dateInfraction"]').html(myResult.saisieCBInfos.libelleDateInfraction);

				//on initialise les valeurs du bloc d'informations de saisiecb
				$('#paiementsips2 #numero-telepaiement-value').html(format_numero_telepaiement_with_hyphen(mySaisieCBInfos.numeroTelepaiement));
				$('#paiementsips2 #date-infraction-value').html(mySaisieCBInfos.dateInfraction);
				$('#paiementsips2 #date-avis-value').html(mySaisieCBInfos.dateAvis);
				if (mySaisieCBInfos.natureInfraction && !('' == mySaisieCBInfos.natureInfraction)) {
					
					$('#paiementsips2 #nature-infraction-value').show();
					$('#paiementsips2 #nature-infraction-value').html(mySaisieCBInfos.natureInfraction);
				}
				else {
					$('#paiementsips2 #nature-infraction-value').hide();
				}
					
				
				$('#paiementsips2 #montant-amande-value').html(formatNombre(mySaisieCBInfos.montant,2,',')+' &euro;');

				$.mobile.changePage($('#paiementsips2'));
			}
		});
	//});
}
