valider_formulaireSaisieCb=false;

$('#saisiecb').live('pageshow',function()
{
	setActiveMenu();
	
	setTailleDateValidite();
		
	//affectation du lien retour en fonction de la provenance
	if(amendeConsignable) {
		$('#saisieCBBackButton').attr('href','#choixpaiement');
		$('#saisieCBBButtonEtr').attr('href','#choixpaiement');
	}
	else {
		$('#saisieCBBackButton').attr('href','#saisienumero');
		$('#saisieCBBButtonEtr').attr('href','#saisienumero');
	}
	
	//modification du titre en fonction du mode de r�glement
	if(mode=='paiement')
	{
		$(this).find('.ui-title').text($.i18n.prop('saisiecb.titre_payer'));
	}
	else
	{
		$(this).find('.ui-title').text($.i18n.prop('saisiecb.titre_consigner'));
	}
	
	//affichage sur 2 lignes des titres de bloc lorsque la largeur de l'ecran est <= 320
	if(window.innerWidth <= 320) 
	{
		$('.ui-collapsible-heading-toggle .ui-btn-text').css('white-space','normal');
	}
	
	// on formatte le numero uniquement si la version d'android utilisee est superieur ou egale a 3
	if (androidVersion >= 3) {
		$('#numero-cb').live('keyup',function()
		{
			var myNumero = $('#numero-cb').val();
			myNumero = myNumero.replace(/-/g,'');
			
			var myFormatedNumero = '';
			for(var i=1;i<=myNumero.length;i++)
			{
				myFormatedNumero = myFormatedNumero+myNumero[i-1];
				if(i%4==0 && i!=myNumero.length)
				{
					myFormatedNumero = myFormatedNumero+"-";
				}
			}
				
			$('#numero-cb').val(myFormatedNumero);
		});
	} else {
		$('#numero-cb').attr('maxlength','16');
		$('#numero-cb').attr('size','16');
	}
		
	document.onkeyup=function(e) {				
		if(e.which == 13){
	    	$(document.activeElement).blur();
	    	$('.footer').show();
	    }
	}
});

//contrôle des valeurs de formulaires
$('#saisiecb-submit-bouton').live('click',function()
{
	if (valider_formulaireSaisieCb)
	{
		//on supprime tout message d'erreur � la validation du formulaire
		$.mobile.activePage.find('p.errorMessage').remove();
		
		//on enleve le focus de l'element actif
		$(document.activeElement).blur();
		$('.footer').show();
		
		var confirmerFormulaire = true;
		confirmField($('#saisiecb #typeCarte'));
		
		//RG TAM-IHM 0100.03.01
		var numeroCB = $('#saisiecb #numero-cb').val().replace(/-/g,'');
		if(numeroCB.length==0)
		{
			displayErrors($.i18n.prop('saisiecb.bloc_saisiecb.erreur_numeroCB_vide'),$('#saisiecb #numero-cb'));
			confirmerFormulaire=false;
		}
		else
		{
			//RG TAM-IHM 0100.03.04
			if(numeroCB.length!=16 || !numeroCB.match(/^[0-9]+$/))
			{
				displayErrors($.i18n.prop('saisiecb.bloc_saisiecb.erreur_numeroCB_incomplet'),$('#saisiecb #numero-cb'));
				confirmerFormulaire=false;
			}
			else
			{
				confirmField($('#saisiecb #numero-cb'));
			}
		}
		
		
		//RG TAM-IHM 0100.03.02
		var dateValidite = $('#saisiecb #mois').val() + "/" + $('#saisiecb #annee').val();
		if(dateValidite.length==0)
		{
			displayMessageError($.i18n.prop('saisiecb.bloc_saisiecb.erreur_dateValidite_vide'),$('#saisiecb #mois'));
			displaySourceElementError($('#saisiecb #mois'));
			displaySourceElementError($('#saisiecb #annee'));
			confirmerFormulaire=false;
		}
		else
		{
			var myDateDuJour = new Date();
	
			var myDateCb = new Date();
			//on positionne la date fourni au premier du mois indiqu� ainsi que la date du jour
			//cela permets ainsi aux personnes dont la carte bancaire arrive � �ch�ance fin du mois de toujours payer
			myDateCb.setFullYear(dateValidite.split('/')[1],dateValidite.split('/')[0]-1,'01');
			myDateDuJour.setDate(1);
			
			//RG TAM-IHM 0100.03.05
			if(myDateCb<myDateDuJour)
			{	
				displayMessageError($.i18n.prop('saisiecb.bloc_saisiecb.erreur_dateValidite_invalide'),$('#saisiecb #dateValidite'));
				displaySourceElementError($('#saisiecb #mois'));
				displaySourceElementError($('#saisiecb #annee'));
				confirmerFormulaire=false;
			}
			else
			{
				confirmField($('#saisiecb #mois'));
				confirmField($('#saisiecb #annee'));
			}
		}
		
		//RG TAM-IHM 0100.03.03
		var cryptogramme = $('#saisiecb #cryptogramme').val();
		if(cryptogramme.length==0)
		{
			displayErrors($.i18n.prop('saisiecb.bloc_saisiecb.erreur_cryptogramme_vide'),$('#saisiecb #cryptogramme'));
			confirmerFormulaire=false;
		}
		else
		{
			//RG TAM-IHM 0100.03.06
			if(cryptogramme.length!=3 || !cryptogramme.match(/^[0-9]+$/))
			{
				displayErrors($.i18n.prop('saisiecb.bloc_saisiecb.erreur_cryptogramme_incomplet'),$('#saisiecb #cryptogramme'));
				confirmerFormulaire=false;
			}
			else
			{
				confirmField($('#saisiecb #cryptogramme'));
			}
		}
		if(confirmerFormulaire===true)
		{
			if(androidVersion < 3) {
				setTimeout(function()
				{
					$.mobile.changePage($('#recapitulatif'));
				},250);
			}
			else {
				$.mobile.changePage($('#recapitulatif'));
			}
		}
	
	}
	valider_formulaireSaisieCb=false;
});

$('#numero-cb,#cryptogramme,#typeCarte,#mois,#annee').live('focus',function()
{
	$('.footer').hide();
});

$('#numero-cb,#cryptogramme,#typeCarte,#mois,#annee').live('blur',function()
{	
	if (androidVersion != '4.2') 
	{
		afficherFooterSaisiCb();
	}
	else
	{		
		setTimeout(function () {		
			afficherFooterSaisiCb();
			//pb avec un HTC ONE XL avec une version android 4.2.2
			//on force le scroll pour faire disparaitre (de force) le clavier virtuel
			//permet d'afficher la page correctement
			if(androidVersion == '4.2') {
				window.scrollTo(0,0);
			}
		},250);	
	}
});

function setFlagSaisieCb() {
	valider_formulaireSaisieCb = true;
}

function validerFormulaireSaisieCb()
{
	setTimeout(function () 
	{
		$('.footer').show();
		
		if (valider_formulaireSaisieCb)
		{
			$('#saisiecb-submit-bouton').click();
		}
	},500);
}

function afficherFooterSaisiCb()
{	
	if ('numero-cb' != $(document.activeElement).attr('id') && 'cryptogramme' != $(document.activeElement).attr('id') && 'typeCarte' != $(document.activeElement).attr('id') && 'mois' != $(document.activeElement).attr('id') && 'annee' != $(document.activeElement).attr('id')) 
	{
		$('.footer').show();
	}
}

function setTailleDateValidite()
{
	var tailleSelect = 50;
	
	while ( $('#saisiecb #saisiecb-form #dateValidite').height() > ($('#saisiecb #saisiecb-form #typeCarte').closest('div').height() * 2) )
	{	
		tailleSelect = tailleSelect -1;
		$('#saisiecb #saisiecb-form #dateValidite .ui-select').css('width',tailleSelect+'%');
	}
}
